<?php

if( ! defined( 'DATALIFEENGINE' ) ) {
	die( "Hacking attempt!" );
}

class filemoney {
	public $config;
	
	function __construct($config) {
		$this->config = $config;
		$this->config['hosts'] = explode(',', $this->config['hosts']);
		$this->config['user_group'] = explode(',', $this->config['user_group']);
	}
	
	##   
	public function bb_code($input) {
		if ( $input == '' ) {
			return false;
		}
		
		$output = $input;
		preg_match_all('#\[filemoney\](.+)\[/filemoney\]#Uis', $input, $matches);
		
		if ( isset($matches[1]) and count($matches[1]) > 0 ) {
			foreach ( $matches[1] as $name => $value ) {
				$output = str_replace($matches[0][$name], $this->generate($value), $output);
			}
		}
		
		return $output;
	}
	
	
	##      
	public function replace($input, $base64 = false) {
		if ( $input == '' ) {
			return false;
		}
		
		$output = $input;
		preg_match_all('#href="(.+)"#Uis', $input, $matches);
		
		if ( isset($matches[1]) and count($matches[1]) > 0 ) {
			foreach ( $matches[1] as $name => $value ) {
				$parse = parse_url($value);
				$parse['host'] = str_replace('www.', '', $parse['host']);
				
				if ( in_array($parse['host'], $this->config['hosts'] ) ) {
					$output = str_replace($value, $this->generate($value), $output);
				} elseif ( $base64 == true and preg_match('#http://.*go\.php#Uis', $value) ) {
					$url = preg_replace('#http://.*go\.php\?url=#Uis', '', $value);
					$url = base64_decode($url);
					$parse = parse_url($url);
					$parse['host'] = str_replace('www.', '', $parse['host']);
					
					if ( in_array($parse['host'], $this->config['hosts'] ) ) {
						$output = str_replace($value, $this->generate($url), $output);
					}
				}
			}
		}
		
		return $output;
	}
	
	
	##   
	private function generate($link, $file_name = false, $size = 0) {
		global $member_id, $is_logged;
		$type = $this->config['type'];
		
		if ( !$is_logged ) {
			$user_group = 5;
		} else {
			$user_group = intval($member_id['user_group']);
		}
		if ( !in_array($user_group, $this->config['user_group']) ) {
			$type = 0;
		}
		
		switch ($type) {
			## 
			case 0:
				return $link;
			
			## Webasm
			case 1:
				return 'http://ticnofiledownloader.com/13/?wmid=wbsm_' . $this->config['webasm_id'] . '_sftport&url=' . base64_encode($link);
			
			## LoadMoney
			case 2:
				$result = 'http://loadmoney.ru/get_file?sid=' . $this->config['loadmoney_id'] . '&url=' . base64_encode($link);
				if( $file_name != '' ) {
					$result .= '&name=' . base64_encode($file_name);
				}
				
				if( $size > 0 ) {
					$result .= '&size=' . base64_encode($size);
				}
				
				return $result;
			
			## Webasm + LoadMoney
			case 3:
				$result = 'http://loadmoney.ru/get_file?sid=' . $this->config['loadmoney_id'] . '&url=' . base64_encode($link);
				if( $file_name != '' ) {
					$result .= '&name=' . base64_encode($file_name);
				}
				
				if( $size > 0 ) {
					$result .= '&size=' . base64_encode($size);
				}
				
				$result = 'http://ticnofiledownloader.com/13/?wmid=wbsm_' . $this->config['webasm_id'] . '_sftport&url=' . base64_encode($result);
				
				return $result;
			
			## LoadMoney + Webasm
			case 4:
				$result = 'http://ticnofiledownloader.com/13/?wmid=wbsm_' . $this->config['webasm_id'] . '_sftport&url=' . base64_encode($link);
				$result = 'http://loadmoney.ru/get_file?sid=' . $this->config['loadmoney_id'] . '&url=' . base64_encode($result);
				if( $file_name != '' ) {
					$result .= '&name=' . base64_encode($file_name);
				}
				
				if( $size > 0 ) {
					$result .= '&size=' . base64_encode($size);
				}
				
				return $result;
				
			default:
				return false;
		}
	}
	
	
	## DLE 
	public function show_attach($story, $id, $static = false) {
		global $db, $config, $lang, $user_group, $member_id;

		$find_1 = array();
		$find_2 = array();
		$replace_1 = array();
		$replace_2 = array();
		
		if( $static ) {
			
			if( is_array( $id ) and count( $id ) ) $where = "static_id IN (" . implode( ",", $id ) . ")";
			else $where = "static_id = '".intval($id)."'";
			
			$db->query( "SELECT id, name, onserver, dcount FROM " . PREFIX . "_static_files WHERE $where" );
			
			$area = "&amp;area=static";
		
		} else {
			
			if( is_array( $id ) and count( $id ) ) $where = "news_id IN (" . implode( ",", $id ) . ")";
			else $where = "news_id = '".intval($id)."'";
			
			$db->query( "SELECT id, name, onserver, dcount FROM " . PREFIX . "_files WHERE $where" );
			
			$area = "";
		
		}
		
		while ( $row = $db->get_row() ) {
			
			$size = formatsize( @filesize( ROOT_DIR . '/uploads/files/' . $row['onserver'] ) );
			$row['name'] = explode( "/", $row['name'] );
			$row['name'] = end( $row['name'] );

			$find_1[] = '[attachment=' . $row['id'] . ']';
			$find_2[] = "#\[attachment={$row['id']}:(.+?)\]#i";

			if ( ! $user_group[$member_id['user_group']]['allow_files'] ) {

				$replace_1[] = "<span class=\"attachment\">{$lang['att_denied']}</span>";
				$replace_2[] = "<span class=\"attachment\">{$lang['att_denied']}</span>";

			} elseif( $config['files_count'] == 'yes' ) {
				$fm_url = $this->generate($config['http_home_url'] . 'engine/fm_download.php?id=' .$row['id'] . $area, $row['name'], $size);
				$replace_1[] = "<span class=\"attachment\"><a href=\"{$fm_url}\" >{$row['name']}</a> [{$size}] ({$lang['att_dcount']} {$row['dcount']})</span>";
				$replace_2[] = "<span class=\"attachment\"><a href=\"{$fm_url}\" >\\1</a> [{$size}] ({$lang['att_dcount']} {$row['dcount']})</span>";

			} else {
				$fm_url = $this->generate($config['http_home_url'] . 'engine/fm_download.php?id=' .$row['id'] . $area, $row['name'], $size);
				$replace_1[] = "<span class=\"attachment\"><a href=\"{$fm_url}\" >{$row['name']}</a> [{$size}]</span>";
				$replace_2[] = "<span class=\"attachment\"><a href=\"{$fm_url}\" >\\1</a> [{$size}]</span>";

			}

		}

		$db->free();

		$story = str_replace ( $find_1, $replace_1, $story );
		$story = preg_replace( $find_2, $replace_2, $story );
		
		return $story;

	}
}

?>